> For the complete documentation index, see [llms.txt](https://help.santesuite.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://help.santesuite.org/developers/service-apis/health-data-service-interface-hdsi/api-documentation/health-data-service-interface-hdsi.md).

# Health Data Service Interface (HDSI)

## GET /time

> Time

```json
{"openapi":"3.1.1","info":{"title":"Health Data Service Interface (HDSI)","version":"3.0.2087.0 (3.0.2087-alpha+44962b8b129307d368c5d1fac08f1f6c31d960ad)"},"servers":[{"url":"https://ims-ncc1701.santesuite.net:8443/hdsi"}],"security":[],"paths":{"/time":{"get":{"tags":[],"summary":"Time","responses":{"200":{"description":"Operation was completed successfully","type":"object"},"400":{"description":"The provided resource was in an incorrect format","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"401":{"description":"The principal is unauthorized and needs to either elevate or authenticate themselves","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"403":{"description":"The principal is not permitted (cannot elevate) to perform the operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"404":{"description":"The requested object does not exist","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"410":{"description":"The specified object did exist however is no-longer present","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"415":{"description":"The client is submitting an invalid object","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"422":{"description":"There was a business rule violation executing the operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"429":{"description":"The server rejected the request due to a throttling constraint","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"500":{"description":"The server encountered an error processing the result","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"503":{"description":"The service is not available (starting up or shutting down)","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}}},"deprecated":true}}},"components":{"schemas":{"RestServiceFault":{"xml":{"attribute":false,"namespace":"http://santedb.org/fault"},"properties":{"data":{"xml":{"name":"data","attribute":false},"description":"Gets or sets any additional data","type":"array","items":{"type":"string"}},"type":{"xml":{"name":"type","attribute":false},"description":"Gets or sets the type of fault","type":"string"},"message":{"xml":{"name":"message","attribute":false},"description":"Gets or sets the message","type":"string"},"stack":{"xml":{"name":"stack","attribute":false},"description":"Detail of exception","type":"string"},"policyId":{"xml":{"name":"policyId","attribute":false},"description":"Policy ID was violated","type":"string"},"policyName":{"xml":{"name":"policyName","attribute":false},"description":"Policy name that was violated","type":"string"},"policyOutcome":{"xml":{"name":"policyOutcome","attribute":false},"description":"Policy ID was violated","type":"string","enum":["Deny","Elevate","Grant"]},"detail":{"xml":{"name":"detail","attribute":false},"description":"Detail of exception","type":"string"},"cause":{"xml":{"name":"cause","attribute":false},"description":"Gets or sets the caused by","schema":{"$ref":"#/components/schemas/RestServiceFault"}},"rule":{"xml":{"name":"rule","attribute":false},"description":"Gets or sets the rules","type":"array","items":{"$ref":"#/components/schemas/DetectedIssue","type":"object"}}},"description":"REST service fault wrapper","type":"object"},"DetectedIssue":{"xml":{"attribute":false,"namespace":"http://santedb.org/issue"},"properties":{"id":{"xml":{"name":"id","attribute":true},"description":"Gets or sets the identifier of the detected issue","type":"string"},"priority":{"xml":{"name":"priority","attribute":true},"description":"Represents a detected issue priority","type":"string","enum":["Error","Warning","Information"]},"text":{"description":"Gets or sets the textual description of the detected issue.","type":"string"},"type":{"xml":{"name":"type","attribute":true},"description":"The type of detected issue (a concept key) which can be used to classify the detected issue","type":"string","format":"uuid"},"refersTo":{"xml":{"name":"refersTo","attribute":true},"description":"Gets or sets the object that the detected issue refers to","type":"string"}},"description":"An issue raised by CDSS, Business Rules, or the persistence layer representing a constraint on the object","type":"object"}}}}
```

## GET /xsd

> GetSchema

```json
{"openapi":"3.1.1","info":{"title":"Health Data Service Interface (HDSI)","version":"3.0.2087.0 (3.0.2087-alpha+44962b8b129307d368c5d1fac08f1f6c31d960ad)"},"servers":[{"url":"https://ims-ncc1701.santesuite.net:8443/hdsi"}],"security":[],"paths":{"/xsd":{"get":{"tags":[],"summary":"GetSchema","responses":{"200":{"description":"Operation was completed successfully","type":"object","content":{"application/json":{"schema":{"$ref":"#/components/schemas/XmlSchema"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/XmlSchema"}},"application/xml":{"schema":{"$ref":"#/components/schemas/XmlSchema"}}}},"400":{"description":"The provided resource was in an incorrect format","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"401":{"description":"The principal is unauthorized and needs to either elevate or authenticate themselves","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"403":{"description":"The principal is not permitted (cannot elevate) to perform the operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"404":{"description":"The requested object does not exist","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"410":{"description":"The specified object did exist however is no-longer present","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"415":{"description":"The client is submitting an invalid object","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"422":{"description":"There was a business rule violation executing the operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"429":{"description":"The server rejected the request due to a throttling constraint","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"500":{"description":"The server encountered an error processing the result","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"503":{"description":"The service is not available (starting up or shutting down)","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}}},"deprecated":false}}},"components":{"schemas":{"XmlSchema":{"properties":{"include":{"xml":{"name":"include","attribute":false},"type":"array","items":{"type":"object"}},"simpleType":{"xml":{"name":"simpleType","attribute":false},"type":"array","items":{"type":"object"}}},"type":"object"},"RestServiceFault":{"xml":{"attribute":false,"namespace":"http://santedb.org/fault"},"properties":{"data":{"xml":{"name":"data","attribute":false},"description":"Gets or sets any additional data","type":"array","items":{"type":"string"}},"type":{"xml":{"name":"type","attribute":false},"description":"Gets or sets the type of fault","type":"string"},"message":{"xml":{"name":"message","attribute":false},"description":"Gets or sets the message","type":"string"},"stack":{"xml":{"name":"stack","attribute":false},"description":"Detail of exception","type":"string"},"policyId":{"xml":{"name":"policyId","attribute":false},"description":"Policy ID was violated","type":"string"},"policyName":{"xml":{"name":"policyName","attribute":false},"description":"Policy name that was violated","type":"string"},"policyOutcome":{"xml":{"name":"policyOutcome","attribute":false},"description":"Policy ID was violated","type":"string","enum":["Deny","Elevate","Grant"]},"detail":{"xml":{"name":"detail","attribute":false},"description":"Detail of exception","type":"string"},"cause":{"xml":{"name":"cause","attribute":false},"description":"Gets or sets the caused by","schema":{"$ref":"#/components/schemas/RestServiceFault"}},"rule":{"xml":{"name":"rule","attribute":false},"description":"Gets or sets the rules","type":"array","items":{"$ref":"#/components/schemas/DetectedIssue","type":"object"}}},"description":"REST service fault wrapper","type":"object"},"DetectedIssue":{"xml":{"attribute":false,"namespace":"http://santedb.org/issue"},"properties":{"id":{"xml":{"name":"id","attribute":true},"description":"Gets or sets the identifier of the detected issue","type":"string"},"priority":{"xml":{"name":"priority","attribute":true},"description":"Represents a detected issue priority","type":"string","enum":["Error","Warning","Information"]},"text":{"description":"Gets or sets the textual description of the detected issue.","type":"string"},"type":{"xml":{"name":"type","attribute":true},"description":"The type of detected issue (a concept key) which can be used to classify the detected issue","type":"string","format":"uuid"},"refersTo":{"xml":{"name":"refersTo","attribute":true},"description":"Gets or sets the object that the detected issue refers to","type":"string"}},"description":"An issue raised by CDSS, Business Rules, or the persistence layer representing a constraint on the object","type":"object"}}}}
```

## OPTIONS /

> Options

```json
{"openapi":"3.1.1","info":{"title":"Health Data Service Interface (HDSI)","version":"3.0.2087.0 (3.0.2087-alpha+44962b8b129307d368c5d1fac08f1f6c31d960ad)"},"servers":[{"url":"https://ims-ncc1701.santesuite.net:8443/hdsi"}],"security":[],"paths":{"/":{"options":{"tags":[],"summary":"Options","responses":{"200":{"description":"Operation was completed successfully","type":"object","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ServiceOptions"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/ServiceOptions"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ServiceOptions"}}}},"400":{"description":"The provided resource was in an incorrect format","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"401":{"description":"The principal is unauthorized and needs to either elevate or authenticate themselves","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"403":{"description":"The principal is not permitted (cannot elevate) to perform the operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"404":{"description":"The requested object does not exist","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"410":{"description":"The specified object did exist however is no-longer present","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"415":{"description":"The client is submitting an invalid object","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"422":{"description":"There was a business rule violation executing the operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"429":{"description":"The server rejected the request due to a throttling constraint","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"500":{"description":"The server encountered an error processing the result","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"503":{"description":"The service is not available (starting up or shutting down)","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}}},"deprecated":false}}},"components":{"schemas":{"ServiceOptions":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"version":{"xml":{"name":"version","attribute":true},"description":"Gets or sets the version of the service interface","type":"string"},"server":{"xml":{"name":"server","attribute":true},"description":"Gets the server informational version","type":"string"},"resource":{"xml":{"name":"resource","attribute":false},"description":"Gets the service resource options","type":"array","items":{"$ref":"#/components/schemas/ServiceResourceOptions","type":"object"}},"endpoint":{"xml":{"name":"endpoint","attribute":false},"description":"Gets or sets the endpoint options","type":"array","items":{"$ref":"#/components/schemas/ServiceEndpointOptions","type":"object"}},"settings":{"xml":{"name":"settings","attribute":false},"description":"Gets or sets the flags on the service","type":"array","items":{"$ref":"#/components/schemas/AppSettingKeyValuePair","type":"object"}},"modifiedOn":{"xml":{"name":"modifiedOn","attribute":false},"description":"Gets or sets the modified on date time of the service options.","type":"string","format":"date"},"id":{"xml":{"name":"id","attribute":false},"description":"Gets or sets the primary identifying UUID of this object","type":"string","format":"uuid"},"operation":{"xml":{"name":"operation","attribute":true},"description":"Gets or sets the operation","type":"string","enum":["Auto","Insert","InsertOrUpdate","Update","Delete","Ignore","DeletePreserveContained"]},"$type":{"description":"Gets the type registration of this object","type":"string"}},"description":"Service options","type":"object"},"ServiceResourceOptions":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"resource":{"xml":{"name":"resource","attribute":true},"description":"Gets the name of the resource","type":"string"},"cap":{"xml":{"name":"cap","attribute":false},"description":"Gets or sets the operations supported by this resource","type":"array","items":{"$ref":"#/components/schemas/ServiceResourceCapability","type":"object"}},"children":{"xml":{"name":"children","attribute":false},"description":"Gets the resources which are associated with this resource (sub-resources)","type":"array","items":{"$ref":"#/components/schemas/ChildServiceResourceOptions","type":"object"}}},"description":"Service resource options","type":"object"},"ServiceResourceCapability":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"cap":{"xml":{"name":"cap","attribute":true},"description":"Gets or sets the capabilities","type":"string","enum":["none","create","create-update","update","delete","patch","get","get-version","history","search"]},"demand":{"xml":{"name":"demand","attribute":false},"description":"Gets or sets the demand","type":"array","items":{"type":"string"}}},"description":"Service resource options","type":"object"},"ChildServiceResourceOptions":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"scope":{"xml":{"name":"scope","attribute":true},"description":"Gets or sets the scope of this object.","type":"string","enum":["instance","class"]},"classification":{"xml":{"name":"classification","attribute":true},"description":"Gets or sets the classification of this object","type":"string","enum":["resource","operation"]},"resource":{"xml":{"name":"resource","attribute":true},"description":"Gets the name of the resource","type":"string"},"cap":{"xml":{"name":"cap","attribute":false},"description":"Gets or sets the operations supported by this resource","type":"array","items":{"$ref":"#/components/schemas/ServiceResourceCapability","type":"object"}},"children":{"xml":{"name":"children","attribute":false},"description":"Gets the resources which are associated with this resource (sub-resources)","type":"array","items":{"$ref":"#/components/schemas/ChildServiceResourceOptions","type":"object"}}},"description":"Child service resource options","type":"object"},"ServiceEndpointOptions":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"type":{"xml":{"name":"type","attribute":true},"description":"The classification of the service (such as HDSI, AMI, IDP, etc.) which this registration represents","type":"string","enum":["hdsi","risi","ami","pixpdq","fhir","v2","gs1","acs","meta","bis","other","app","web"]},"cap":{"xml":{"name":"cap","attribute":true},"description":"The capabilities of this service (compression, bearer authentication, etc.) which is used by clients to negotiate server capacity","type":"string","enum":["none","basic","bearer","compress","nodeauth","cors","viewModel","standardApi","standardApiCors","internalApi","idpApi"]},"security":{"xml":{"name":"security","attribute":true},"description":"Identifies the security methods on the provider","type":"string","enum":["None","Basic","Bearer","ClientCertificate"]},"url":{"xml":{"name":"url","attribute":true},"description":"The URLs where the remote service described by the service type can be accessed","type":"array","items":{"type":"string"}},"contract":{"xml":{"name":"contract","attribute":false},"description":"Gets or sets the contract","type":"array","items":{"$ref":"#/components/schemas/TypeReferenceConfiguration","type":"object"}},"behavior":{"xml":{"name":"behavior","attribute":false},"description":"The service implementation which this remote service implements (which is used to drive metadata collection)","schema":{"$ref":"#/components/schemas/TypeReferenceConfiguration"}}},"description":"Service endpoint options","type":"object"},"TypeReferenceConfiguration":{"xml":{"attribute":false,"namespace":"http://santedb.org/configuration"},"properties":{"type":{"xml":{"name":"type","attribute":true},"description":"Gets the type","type":"string"}},"description":"Represents a class that can be used to reference types in configuration files","type":"object"},"AppSettingKeyValuePair":{"xml":{"attribute":false,"namespace":"http://santedb.org/configuration"},"properties":{"key":{"xml":{"name":"key","attribute":true},"description":"The key of the setting","type":"string"},"value":{"xml":{"name":"value","attribute":true},"description":"The value of the setting","type":"string"}},"description":"Application key/value pair setting","type":"object"},"RestServiceFault":{"xml":{"attribute":false,"namespace":"http://santedb.org/fault"},"properties":{"data":{"xml":{"name":"data","attribute":false},"description":"Gets or sets any additional data","type":"array","items":{"type":"string"}},"type":{"xml":{"name":"type","attribute":false},"description":"Gets or sets the type of fault","type":"string"},"message":{"xml":{"name":"message","attribute":false},"description":"Gets or sets the message","type":"string"},"stack":{"xml":{"name":"stack","attribute":false},"description":"Detail of exception","type":"string"},"policyId":{"xml":{"name":"policyId","attribute":false},"description":"Policy ID was violated","type":"string"},"policyName":{"xml":{"name":"policyName","attribute":false},"description":"Policy name that was violated","type":"string"},"policyOutcome":{"xml":{"name":"policyOutcome","attribute":false},"description":"Policy ID was violated","type":"string","enum":["Deny","Elevate","Grant"]},"detail":{"xml":{"name":"detail","attribute":false},"description":"Detail of exception","type":"string"},"cause":{"xml":{"name":"cause","attribute":false},"description":"Gets or sets the caused by","schema":{"$ref":"#/components/schemas/RestServiceFault"}},"rule":{"xml":{"name":"rule","attribute":false},"description":"Gets or sets the rules","type":"array","items":{"$ref":"#/components/schemas/DetectedIssue","type":"object"}}},"description":"REST service fault wrapper","type":"object"},"DetectedIssue":{"xml":{"attribute":false,"namespace":"http://santedb.org/issue"},"properties":{"id":{"xml":{"name":"id","attribute":true},"description":"Gets or sets the identifier of the detected issue","type":"string"},"priority":{"xml":{"name":"priority","attribute":true},"description":"Represents a detected issue priority","type":"string","enum":["Error","Warning","Information"]},"text":{"description":"Gets or sets the textual description of the detected issue.","type":"string"},"type":{"xml":{"name":"type","attribute":true},"description":"The type of detected issue (a concept key) which can be used to classify the detected issue","type":"string","format":"uuid"},"refersTo":{"xml":{"name":"refersTo","attribute":true},"description":"Gets or sets the object that the detected issue refers to","type":"string"}},"description":"An issue raised by CDSS, Business Rules, or the persistence layer representing a constraint on the object","type":"object"}}}}
```

## PATCH /

> Performs a patch on all resources in the

```json
{"openapi":"3.1.1","info":{"title":"Health Data Service Interface (HDSI)","version":"3.0.2087.0 (3.0.2087-alpha+44962b8b129307d368c5d1fac08f1f6c31d960ad)"},"servers":[{"url":"https://ims-ncc1701.santesuite.net:8443/hdsi"}],"security":[],"paths":{"/":{"patch":{"tags":[],"summary":"Performs a patch on all resources in the","responses":{"204":{"description":"There is not response for this method"},"400":{"description":"The provided resource was in an incorrect format","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"401":{"description":"The principal is unauthorized and needs to either elevate or authenticate themselves","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"403":{"description":"The principal is not permitted (cannot elevate) to perform the operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"404":{"description":"The requested object does not exist","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"409":{"description":"One or more of the patch instructions provided does not match the current version of the object being patched","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"410":{"description":"The specified object did exist however is no-longer present","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"415":{"description":"The client is submitting an invalid object","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"422":{"description":"There was a business rule violation executing the operation","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"429":{"description":"The server rejected the request due to a throttling constraint","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"500":{"description":"The server encountered an error processing the result","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}},"503":{"description":"The service is not available (starting up or shutting down)","content":{"application/json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}},"application/xml":{"schema":{"$ref":"#/components/schemas/RestServiceFault"}}}}},"deprecated":false,"requestBody":{"content":{"application/x.santedb.rim.viewModel+json":{"schema":{"$ref":"#/components/schemas/PatchCollection"}},"application/json":{"schema":{"$ref":"#/components/schemas/PatchCollection"}},"application/xml":{"schema":{"$ref":"#/components/schemas/PatchCollection"}}},"description":"The collection of patches which are to be applied"}}}},"components":{"schemas":{"RestServiceFault":{"xml":{"attribute":false,"namespace":"http://santedb.org/fault"},"properties":{"data":{"xml":{"name":"data","attribute":false},"description":"Gets or sets any additional data","type":"array","items":{"type":"string"}},"type":{"xml":{"name":"type","attribute":false},"description":"Gets or sets the type of fault","type":"string"},"message":{"xml":{"name":"message","attribute":false},"description":"Gets or sets the message","type":"string"},"stack":{"xml":{"name":"stack","attribute":false},"description":"Detail of exception","type":"string"},"policyId":{"xml":{"name":"policyId","attribute":false},"description":"Policy ID was violated","type":"string"},"policyName":{"xml":{"name":"policyName","attribute":false},"description":"Policy name that was violated","type":"string"},"policyOutcome":{"xml":{"name":"policyOutcome","attribute":false},"description":"Policy ID was violated","type":"string","enum":["Deny","Elevate","Grant"]},"detail":{"xml":{"name":"detail","attribute":false},"description":"Detail of exception","type":"string"},"cause":{"xml":{"name":"cause","attribute":false},"description":"Gets or sets the caused by","schema":{"$ref":"#/components/schemas/RestServiceFault"}},"rule":{"xml":{"name":"rule","attribute":false},"description":"Gets or sets the rules","type":"array","items":{"$ref":"#/components/schemas/DetectedIssue","type":"object"}}},"description":"REST service fault wrapper","type":"object"},"DetectedIssue":{"xml":{"attribute":false,"namespace":"http://santedb.org/issue"},"properties":{"id":{"xml":{"name":"id","attribute":true},"description":"Gets or sets the identifier of the detected issue","type":"string"},"priority":{"xml":{"name":"priority","attribute":true},"description":"Represents a detected issue priority","type":"string","enum":["Error","Warning","Information"]},"text":{"description":"Gets or sets the textual description of the detected issue.","type":"string"},"type":{"xml":{"name":"type","attribute":true},"description":"The type of detected issue (a concept key) which can be used to classify the detected issue","type":"string","format":"uuid"},"refersTo":{"xml":{"name":"refersTo","attribute":true},"description":"Gets or sets the object that the detected issue refers to","type":"string"}},"description":"An issue raised by CDSS, Business Rules, or the persistence layer representing a constraint on the object","type":"object"},"PatchCollection":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"patch":{"xml":{"name":"patch","attribute":false},"description":"Gets or sets the patches","type":"array","items":{"$ref":"#/components/schemas/Patch","type":"object"}},"modifiedOn":{"xml":{"name":"modifiedOn","attribute":false},"type":"string","format":"date"},"id":{"xml":{"name":"id","attribute":false},"description":"Gets or sets the primary identifying UUID of this object","type":"string","format":"uuid"},"operation":{"xml":{"name":"operation","attribute":true},"description":"Gets or sets the operation","type":"string","enum":["Auto","Insert","InsertOrUpdate","Update","Delete","Ignore","DeletePreserveContained"]},"$type":{"description":"Gets the type registration of this object","type":"string"}},"description":"Represents a collection of patch instructions","type":"object"},"Patch":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"version":{"xml":{"name":"version","attribute":true},"description":"Gets or sets the version of the patch file","type":"string"},"appliesTo":{"xml":{"name":"appliesTo","attribute":false},"description":"Application version","schema":{"$ref":"#/components/schemas/PatchTarget"}},"change":{"xml":{"name":"change","attribute":false},"description":"A list of patch operations to be applied to the object","type":"array","items":{"$ref":"#/components/schemas/PatchOperation","type":"object"}},"creationTime":{"xml":{"name":"creationTime","attribute":false},"description":"Gets or sets the creation time as an ISO date format","type":"string"},"obsoletionTime":{"xml":{"name":"obsoletionTime","attribute":false},"description":"Gets or sets the time that the data is no longer valid (was deleted/obsoleted) in ISO format","type":"string"},"modifiedOn":{"xml":{"name":"modifiedOn","attribute":false},"description":"Gets the time that the object was last modified (from base data, default to CreationTime)","type":"string","format":"date"},"createdBy":{"xml":{"name":"createdBy","attribute":false},"description":"Gets or sets the security provenance object which represents the creation of this object","type":"string","format":"uuid"},"obsoletedBy":{"xml":{"name":"obsoletedBy","attribute":false},"description":"Gets or sets the security provenance object which represents the obsoletion of this data","type":"string","format":"uuid"},"id":{"xml":{"name":"id","attribute":false},"description":"Gets or sets the primary identifying UUID of this object","type":"string","format":"uuid"},"operation":{"xml":{"name":"operation","attribute":true},"description":"Gets or sets the operation","type":"string","enum":["Auto","Insert","InsertOrUpdate","Update","Delete","Ignore","DeletePreserveContained"]},"$type":{"description":"Gets the type registration of this object","type":"string"}},"description":"Represents a series of patch instructions","type":"object"},"PatchTarget":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"type":{"xml":{"name":"type","attribute":true},"description":"Identifies the target type","type":"string"},"id":{"xml":{"name":"id","attribute":false},"description":"Gets or sets the key","type":"string","format":"uuid"},"version":{"xml":{"name":"version","attribute":false},"description":"Gets or sets the key","type":"string","format":"uuid"},"tag":{"xml":{"name":"tag","attribute":false},"description":"Gets or sets the tag of the item","type":"string"}},"description":"Represents a target of a patch","type":"object"},"PatchOperation":{"xml":{"attribute":false,"namespace":"http://santedb.org/model"},"properties":{"op":{"xml":{"name":"op","attribute":true},"description":"Gets or sets the operation type","type":"string","enum":["add","remove","replace","test","test-ne"]},"path":{"xml":{"name":"path","attribute":true},"description":"Gets or sets the path","type":"string"},"value":{"xml":{"name":"value","attribute":false},"description":"Get or sets the value","schema":{"$ref":"#/components/schemas/Object"}}},"description":"Represents a single patch operation","type":"object"},"Object":{"properties":{},"type":"object"}}}}
```
